/*	Copyright (c) 1991 Richard F. Man.  All rights reserved.
 *	man@labrea.zko.dec.com, P.O. Box 6, North Chelmsford, MA 01863
 *	tabstop=4
 *
 *	$Log: exec.h%v $
 * Revision 1.1  1991/12/08  22:12:48  rfm
 * Initial revision
 *
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <setjmp.h>

#ifndef STRATOM_H
#include "stratom.h"
#endif

#ifndef YES
#define YES 1
#define NO  0
typedef int BOOL;
#endif

#ifndef BIT
#define BIT(i)  (1 << (i))
#endif

/*	different perfixes for EXEC_ID
 */
#define PORT_PREFIX         BIT(15)
#define SEMAPHORE_PREFIX    BIT(14)
#define TIMER_PREFIX        BIT(13)
#define MONOSTABLE_PREFIX   BIT(12)
#define TRIGGER_PREFIX      BIT(11)

#define BAD_EXEC_ID 		-1

typedef int 			EXEC_ID;
typedef signed char 	THREAD_ID;

typedef unsigned int	PORT;
typedef unsigned int	SEMAPHORE;

/*	process type.  Not used yet
 */
typedef enum
    { NORMAL_PROC = 10, HALTABLE_PROC, INHIBITABLE_PROC } PROCESS_TYPE;

void *ExecAlloc(unsigned int size);
THREAD_ID ExecCreateThread(PROCESS_TYPE procType, void (*pFunction)(void), 
    unsigned int stackSize, unsigned long arg0, unsigned long arg1);
EXEC_ID ExecExecID(unsigned int prefix);
THREAD_ID ExecGetThreadID(void);
void ExecInit(void);
void ExecStart(void);

void MsgClearSemaphore(STRING_ATOM semaphoreAtom);
BOOL MsgConnectPorts(STRING_ATOM sourceAtom, STRING_ATOM destinationAtom);
void MsgDeleteTimer(EXEC_ID watchID);
EXEC_ID MsgGetMsg(void);
BOOL MsgInhibitPorts(STRING_ATOM sourceAtom, STRING_ATOM destinationAtom);
void *MsgOpenPort(STRING_ATOM nameAtom, PORT *pPortValue);
PORT MsgPeekPort(STRING_ATOM, PORT *);
void MsgSetSemaphore(STRING_ATOM semaphoreAtom);
BOOL MsgSuppressPorts(STRING_ATOM sourceAtom, STRING_ATOM destinationAtom);
EXEC_ID MsgWatchPort(STRING_ATOM portAtom, PORT *pPortValue);
EXEC_ID MsgWatchSemaphore(STRING_ATOM semaphoreAtom, BOOL detectOn);
EXEC_ID MsgWatchTimer(unsigned int interval);
void MsgWriteToPort(STRING_ATOM portAtom, PORT portValue);

#define MsgWatchTrigger(portAtom) MsgWatchPort(portAtom, NULL)

void SysLEDs(int i);

typedef unsigned
#ifdef HC11
int
#else
long
#endif
EXEC_ARG;

extern EXEC_ARG ExecArg0, ExecArg1;
